EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_TEXTBLOCK_EVENT_CHANGED =
   EFL_EVENT_DESCRIPTION("changed");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_TEXTBLOCK_EVENT_LAYOUT_FINISHED =
   EFL_EVENT_DESCRIPTION("layout,finished");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_TEXTBLOCK_EVENT_STYLE_INSETS_CHANGED =
   EFL_EVENT_DESCRIPTION("style_insets,changed");

Eina_Bool _efl_canvas_textblock_is_empty_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


static Eina_Value
__eolian_efl_canvas_textblock_is_empty_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_textblock_is_empty_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_textblock_is_empty_get, Eina_Bool, 0);

Efl_Text_Cursor_Object *_efl_canvas_textblock_cursor_create(Eo *obj, Efl_Canvas_Textblock_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY(efl_canvas_textblock_cursor_create, Efl_Text_Cursor_Object *, NULL);

Eina_Bool _efl_canvas_textblock_visible_range_get(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Cursor_Object *start, Efl_Text_Cursor_Object *end);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV(efl_canvas_textblock_visible_range_get, Eina_Bool, 0, EFL_FUNC_CALL(start, end), Efl_Text_Cursor_Object *start, Efl_Text_Cursor_Object *end);

void _efl_canvas_textblock_style_insets_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, int *l, int *r, int *t, int *b);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_canvas_textblock_style_insets_get, EFL_FUNC_CALL(l, r, t, b), int *l, int *r, int *t, int *b);

void _efl_canvas_textblock_bidi_delimiters_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *delim);


static Eina_Error
__eolian_efl_canvas_textblock_bidi_delimiters_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   const char *cval;
   if (!eina_value_string_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_textblock_bidi_delimiters_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_textblock_bidi_delimiters_set, EFL_FUNC_CALL(delim), const char *delim);

const char *_efl_canvas_textblock_bidi_delimiters_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


static Eina_Value
__eolian_efl_canvas_textblock_bidi_delimiters_get_reflect(const Eo *obj)
{
   const char *val = efl_canvas_textblock_bidi_delimiters_get(obj);
   return eina_value_string_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_textblock_bidi_delimiters_get, const char *, NULL);

void _efl_canvas_textblock_newline_as_paragraph_separator_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Eina_Bool mode);


static Eina_Error
__eolian_efl_canvas_textblock_newline_as_paragraph_separator_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_textblock_newline_as_paragraph_separator_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_textblock_newline_as_paragraph_separator_set, EFL_FUNC_CALL(mode), Eina_Bool mode);

Eina_Bool _efl_canvas_textblock_newline_as_paragraph_separator_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


static Eina_Value
__eolian_efl_canvas_textblock_newline_as_paragraph_separator_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_textblock_newline_as_paragraph_separator_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_textblock_newline_as_paragraph_separator_get, Eina_Bool, 0);

void _efl_canvas_textblock_style_apply(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *style);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_textblock_style_apply, EFL_FUNC_CALL(style), const char *style);

const char *_efl_canvas_textblock_all_styles_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


static Eina_Value
__eolian_efl_canvas_textblock_all_styles_get_reflect(const Eo *obj)
{
   const char *val = efl_canvas_textblock_all_styles_get(obj);
   return eina_value_string_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_textblock_all_styles_get, const char *, NULL);

Eina_Size2D _efl_canvas_textblock_size_formatted_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_textblock_size_formatted_get, Eina_Size2D, ((Eina_Size2D){0}));

Eina_Size2D _efl_canvas_textblock_size_native_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_textblock_size_native_get, Eina_Size2D, ((Eina_Size2D){0}));

Eina_Bool _efl_canvas_textblock_obstacle_add(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Canvas_Object *eo_obs);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV(efl_canvas_textblock_obstacle_add, Eina_Bool, 0, EFL_FUNC_CALL(eo_obs), Efl_Canvas_Object *eo_obs);

Eina_Bool _efl_canvas_textblock_obstacle_del(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Canvas_Object *eo_obs);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV(efl_canvas_textblock_obstacle_del, Eina_Bool, 0, EFL_FUNC_CALL(eo_obs), Efl_Canvas_Object *eo_obs);

void _efl_canvas_textblock_obstacles_update(Eo *obj, Efl_Canvas_Textblock_Data *pd);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODY(efl_canvas_textblock_obstacles_update);

Eina_Future *_efl_canvas_textblock_async_layout(Eo *obj, Efl_Canvas_Textblock_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY(efl_canvas_textblock_async_layout, Eina_Future *, NULL);

Efl_Object *_efl_canvas_textblock_efl_object_constructor(Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_object_destructor(Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_canvas_object_paragraph_direction_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Bidirectional_Type dir);


Efl_Text_Bidirectional_Type _efl_canvas_textblock_efl_canvas_object_paragraph_direction_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_text_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *text);


const char *_efl_canvas_textblock_efl_text_text_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_gfx_filter_filter_program_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *code, const char *name);


void _efl_canvas_textblock_efl_gfx_filter_filter_program_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, const char **code, const char **name);


void _efl_canvas_textblock_efl_gfx_filter_filter_data_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *name, const char *value, Eina_Bool execute);


void _efl_canvas_textblock_efl_gfx_filter_filter_data_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *name, const char **value, Eina_Bool *execute);

static void __eolian_efl_canvas_textblock_efl_gfx_filter_filter_data_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *name, const char **value, Eina_Bool *execute)
{
   if (execute) *execute = EINA_FALSE;
   _efl_canvas_textblock_efl_gfx_filter_filter_data_get(obj, pd, name, value, execute);
}


void _efl_canvas_textblock_efl_gfx_filter_filter_source_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *name, Efl_Gfx_Entity *source);


Efl_Gfx_Entity *_efl_canvas_textblock_efl_gfx_filter_filter_source_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *name);


void _efl_canvas_textblock_efl_canvas_filter_internal_filter_dirty(Eo *obj, Efl_Canvas_Textblock_Data *pd);


Eina_Bool _efl_canvas_textblock_efl_canvas_filter_internal_filter_input_render(Eo *obj, Efl_Canvas_Textblock_Data *pd, void *filter, void *engine, void *output, void *drawctx, void *data, int l, int r, int t, int b, int x, int y, Eina_Bool do_async);


void _efl_canvas_textblock_efl_canvas_filter_internal_filter_state_prepare(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Canvas_Filter_State *state, void *data);


void _efl_canvas_textblock_efl_text_font_properties_font_family_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *font);


const char *_efl_canvas_textblock_efl_text_font_properties_font_family_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_size_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Font_Size size);


Efl_Font_Size _efl_canvas_textblock_efl_text_font_properties_font_size_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_source_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *font_source);


const char *_efl_canvas_textblock_efl_text_font_properties_font_source_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_fallbacks_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *font_fallbacks);


const char *_efl_canvas_textblock_efl_text_font_properties_font_fallbacks_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_lang_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *lang);


const char *_efl_canvas_textblock_efl_text_font_properties_font_lang_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_weight_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Font_Weight font_weight);


Efl_Text_Font_Weight _efl_canvas_textblock_efl_text_font_properties_font_weight_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_slant_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Font_Slant style);


Efl_Text_Font_Slant _efl_canvas_textblock_efl_text_font_properties_font_slant_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_width_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Font_Width width);


Efl_Text_Font_Width _efl_canvas_textblock_efl_text_font_properties_font_width_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_font_properties_font_bitmap_scalable_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Font_Bitmap_Scalable scalable);


Efl_Text_Font_Bitmap_Scalable _efl_canvas_textblock_efl_text_font_properties_font_bitmap_scalable_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_background_type_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Style_Background_Type type);


Efl_Text_Style_Background_Type _efl_canvas_textblock_efl_text_style_text_background_type_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_background_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_background_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_underline_type_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Style_Underline_Type type);


Efl_Text_Style_Underline_Type _efl_canvas_textblock_efl_text_style_text_underline_type_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_underline_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_underline_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_underline_height_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double height);


double _efl_canvas_textblock_efl_text_style_text_underline_height_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_underline_dashed_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_underline_dashed_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_underline_dashed_width_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, int width);


int _efl_canvas_textblock_efl_text_style_text_underline_dashed_width_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_underline_dashed_gap_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, int gap);


int _efl_canvas_textblock_efl_text_style_text_underline_dashed_gap_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_secondary_underline_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_secondary_underline_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_strikethrough_type_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Style_Strikethrough_Type type);


Efl_Text_Style_Strikethrough_Type _efl_canvas_textblock_efl_text_style_text_strikethrough_type_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_strikethrough_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_strikethrough_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_effect_type_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Style_Effect_Type type);


Efl_Text_Style_Effect_Type _efl_canvas_textblock_efl_text_style_text_effect_type_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_outline_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_outline_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_shadow_direction_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Style_Shadow_Direction type);


Efl_Text_Style_Shadow_Direction _efl_canvas_textblock_efl_text_style_text_shadow_direction_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_style_text_shadow_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_shadow_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_glow_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_glow_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_secondary_glow_color_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


void _efl_canvas_textblock_efl_text_style_text_secondary_glow_color_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd, unsigned char *r, unsigned char *g, unsigned char *b, unsigned char *a);


void _efl_canvas_textblock_efl_text_style_text_gfx_filter_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *code);


const char *_efl_canvas_textblock_efl_text_style_text_gfx_filter_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_ellipsis_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double value);


double _efl_canvas_textblock_efl_text_format_ellipsis_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_wrap_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Format_Wrap wrap);


Efl_Text_Format_Wrap _efl_canvas_textblock_efl_text_format_wrap_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_multiline_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Eina_Bool enabled);


Eina_Bool _efl_canvas_textblock_efl_text_format_multiline_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_text_horizontal_align_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double value);


double _efl_canvas_textblock_efl_text_format_text_horizontal_align_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_text_horizontal_align_auto_type_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Efl_Text_Format_Horizontal_Alignment_Auto_Type value);


Efl_Text_Format_Horizontal_Alignment_Auto_Type _efl_canvas_textblock_efl_text_format_text_horizontal_align_auto_type_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_text_vertical_align_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double value);


double _efl_canvas_textblock_efl_text_format_text_vertical_align_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_line_gap_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double value);


double _efl_canvas_textblock_efl_text_format_line_gap_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_line_rel_gap_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double value);


double _efl_canvas_textblock_efl_text_format_line_rel_gap_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_tab_stops_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, int value);


int _efl_canvas_textblock_efl_text_format_tab_stops_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_password_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, Eina_Bool enabled);


Eina_Bool _efl_canvas_textblock_efl_text_format_password_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_format_replacement_char_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *repch);


const char *_efl_canvas_textblock_efl_text_format_replacement_char_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_text_markup_markup_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, const char *markup);


const char *_efl_canvas_textblock_efl_text_markup_markup_get(const Eo *obj, Efl_Canvas_Textblock_Data *pd);


void _efl_canvas_textblock_efl_gfx_entity_scale_set(Eo *obj, Efl_Canvas_Textblock_Data *pd, double scale);


static Eina_Bool
_efl_canvas_textblock_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_TEXTBLOCK_EXTRA_OPS
#define EFL_CANVAS_TEXTBLOCK_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_is_empty_get, _efl_canvas_textblock_is_empty_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_cursor_create, _efl_canvas_textblock_cursor_create),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_visible_range_get, _efl_canvas_textblock_visible_range_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_style_insets_get, _efl_canvas_textblock_style_insets_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_bidi_delimiters_set, _efl_canvas_textblock_bidi_delimiters_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_bidi_delimiters_get, _efl_canvas_textblock_bidi_delimiters_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_newline_as_paragraph_separator_set, _efl_canvas_textblock_newline_as_paragraph_separator_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_newline_as_paragraph_separator_get, _efl_canvas_textblock_newline_as_paragraph_separator_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_style_apply, _efl_canvas_textblock_style_apply),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_all_styles_get, _efl_canvas_textblock_all_styles_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_size_formatted_get, _efl_canvas_textblock_size_formatted_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_size_native_get, _efl_canvas_textblock_size_native_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_obstacle_add, _efl_canvas_textblock_obstacle_add),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_obstacle_del, _efl_canvas_textblock_obstacle_del),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_obstacles_update, _efl_canvas_textblock_obstacles_update),
      EFL_OBJECT_OP_FUNC(efl_canvas_textblock_async_layout, _efl_canvas_textblock_async_layout),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_canvas_textblock_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_canvas_textblock_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_paragraph_direction_set, _efl_canvas_textblock_efl_canvas_object_paragraph_direction_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_paragraph_direction_get, _efl_canvas_textblock_efl_canvas_object_paragraph_direction_get),
      EFL_OBJECT_OP_FUNC(efl_text_set, _efl_canvas_textblock_efl_text_text_set),
      EFL_OBJECT_OP_FUNC(efl_text_get, _efl_canvas_textblock_efl_text_text_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_program_set, _efl_canvas_textblock_efl_gfx_filter_filter_program_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_program_get, _efl_canvas_textblock_efl_gfx_filter_filter_program_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_data_set, _efl_canvas_textblock_efl_gfx_filter_filter_data_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_data_get, __eolian_efl_canvas_textblock_efl_gfx_filter_filter_data_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_source_set, _efl_canvas_textblock_efl_gfx_filter_filter_source_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_filter_source_get, _efl_canvas_textblock_efl_gfx_filter_filter_source_get),
      EFL_OBJECT_OP_FUNC(evas_filter_dirty, _efl_canvas_textblock_efl_canvas_filter_internal_filter_dirty),
      EFL_OBJECT_OP_FUNC(evas_filter_input_render, _efl_canvas_textblock_efl_canvas_filter_internal_filter_input_render),
      EFL_OBJECT_OP_FUNC(evas_filter_state_prepare, _efl_canvas_textblock_efl_canvas_filter_internal_filter_state_prepare),
      EFL_OBJECT_OP_FUNC(efl_text_font_family_set, _efl_canvas_textblock_efl_text_font_properties_font_family_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_family_get, _efl_canvas_textblock_efl_text_font_properties_font_family_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_size_set, _efl_canvas_textblock_efl_text_font_properties_font_size_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_size_get, _efl_canvas_textblock_efl_text_font_properties_font_size_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_source_set, _efl_canvas_textblock_efl_text_font_properties_font_source_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_source_get, _efl_canvas_textblock_efl_text_font_properties_font_source_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_fallbacks_set, _efl_canvas_textblock_efl_text_font_properties_font_fallbacks_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_fallbacks_get, _efl_canvas_textblock_efl_text_font_properties_font_fallbacks_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_lang_set, _efl_canvas_textblock_efl_text_font_properties_font_lang_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_lang_get, _efl_canvas_textblock_efl_text_font_properties_font_lang_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_weight_set, _efl_canvas_textblock_efl_text_font_properties_font_weight_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_weight_get, _efl_canvas_textblock_efl_text_font_properties_font_weight_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_slant_set, _efl_canvas_textblock_efl_text_font_properties_font_slant_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_slant_get, _efl_canvas_textblock_efl_text_font_properties_font_slant_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_width_set, _efl_canvas_textblock_efl_text_font_properties_font_width_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_width_get, _efl_canvas_textblock_efl_text_font_properties_font_width_get),
      EFL_OBJECT_OP_FUNC(efl_text_font_bitmap_scalable_set, _efl_canvas_textblock_efl_text_font_properties_font_bitmap_scalable_set),
      EFL_OBJECT_OP_FUNC(efl_text_font_bitmap_scalable_get, _efl_canvas_textblock_efl_text_font_properties_font_bitmap_scalable_get),
      EFL_OBJECT_OP_FUNC(efl_text_color_set, _efl_canvas_textblock_efl_text_style_text_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_color_get, _efl_canvas_textblock_efl_text_style_text_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_background_type_set, _efl_canvas_textblock_efl_text_style_text_background_type_set),
      EFL_OBJECT_OP_FUNC(efl_text_background_type_get, _efl_canvas_textblock_efl_text_style_text_background_type_get),
      EFL_OBJECT_OP_FUNC(efl_text_background_color_set, _efl_canvas_textblock_efl_text_style_text_background_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_background_color_get, _efl_canvas_textblock_efl_text_style_text_background_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_underline_type_set, _efl_canvas_textblock_efl_text_style_text_underline_type_set),
      EFL_OBJECT_OP_FUNC(efl_text_underline_type_get, _efl_canvas_textblock_efl_text_style_text_underline_type_get),
      EFL_OBJECT_OP_FUNC(efl_text_underline_color_set, _efl_canvas_textblock_efl_text_style_text_underline_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_underline_color_get, _efl_canvas_textblock_efl_text_style_text_underline_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_underline_height_set, _efl_canvas_textblock_efl_text_style_text_underline_height_set),
      EFL_OBJECT_OP_FUNC(efl_text_underline_height_get, _efl_canvas_textblock_efl_text_style_text_underline_height_get),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_color_set, _efl_canvas_textblock_efl_text_style_text_underline_dashed_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_color_get, _efl_canvas_textblock_efl_text_style_text_underline_dashed_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_width_set, _efl_canvas_textblock_efl_text_style_text_underline_dashed_width_set),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_width_get, _efl_canvas_textblock_efl_text_style_text_underline_dashed_width_get),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_gap_set, _efl_canvas_textblock_efl_text_style_text_underline_dashed_gap_set),
      EFL_OBJECT_OP_FUNC(efl_text_underline_dashed_gap_get, _efl_canvas_textblock_efl_text_style_text_underline_dashed_gap_get),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_underline_color_set, _efl_canvas_textblock_efl_text_style_text_secondary_underline_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_underline_color_get, _efl_canvas_textblock_efl_text_style_text_secondary_underline_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_type_set, _efl_canvas_textblock_efl_text_style_text_strikethrough_type_set),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_type_get, _efl_canvas_textblock_efl_text_style_text_strikethrough_type_get),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_color_set, _efl_canvas_textblock_efl_text_style_text_strikethrough_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_strikethrough_color_get, _efl_canvas_textblock_efl_text_style_text_strikethrough_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_effect_type_set, _efl_canvas_textblock_efl_text_style_text_effect_type_set),
      EFL_OBJECT_OP_FUNC(efl_text_effect_type_get, _efl_canvas_textblock_efl_text_style_text_effect_type_get),
      EFL_OBJECT_OP_FUNC(efl_text_outline_color_set, _efl_canvas_textblock_efl_text_style_text_outline_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_outline_color_get, _efl_canvas_textblock_efl_text_style_text_outline_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_direction_set, _efl_canvas_textblock_efl_text_style_text_shadow_direction_set),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_direction_get, _efl_canvas_textblock_efl_text_style_text_shadow_direction_get),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_color_set, _efl_canvas_textblock_efl_text_style_text_shadow_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_shadow_color_get, _efl_canvas_textblock_efl_text_style_text_shadow_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_glow_color_set, _efl_canvas_textblock_efl_text_style_text_glow_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_glow_color_get, _efl_canvas_textblock_efl_text_style_text_glow_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_glow_color_set, _efl_canvas_textblock_efl_text_style_text_secondary_glow_color_set),
      EFL_OBJECT_OP_FUNC(efl_text_secondary_glow_color_get, _efl_canvas_textblock_efl_text_style_text_secondary_glow_color_get),
      EFL_OBJECT_OP_FUNC(efl_text_gfx_filter_set, _efl_canvas_textblock_efl_text_style_text_gfx_filter_set),
      EFL_OBJECT_OP_FUNC(efl_text_gfx_filter_get, _efl_canvas_textblock_efl_text_style_text_gfx_filter_get),
      EFL_OBJECT_OP_FUNC(efl_text_ellipsis_set, _efl_canvas_textblock_efl_text_format_ellipsis_set),
      EFL_OBJECT_OP_FUNC(efl_text_ellipsis_get, _efl_canvas_textblock_efl_text_format_ellipsis_get),
      EFL_OBJECT_OP_FUNC(efl_text_wrap_set, _efl_canvas_textblock_efl_text_format_wrap_set),
      EFL_OBJECT_OP_FUNC(efl_text_wrap_get, _efl_canvas_textblock_efl_text_format_wrap_get),
      EFL_OBJECT_OP_FUNC(efl_text_multiline_set, _efl_canvas_textblock_efl_text_format_multiline_set),
      EFL_OBJECT_OP_FUNC(efl_text_multiline_get, _efl_canvas_textblock_efl_text_format_multiline_get),
      EFL_OBJECT_OP_FUNC(efl_text_horizontal_align_set, _efl_canvas_textblock_efl_text_format_text_horizontal_align_set),
      EFL_OBJECT_OP_FUNC(efl_text_horizontal_align_get, _efl_canvas_textblock_efl_text_format_text_horizontal_align_get),
      EFL_OBJECT_OP_FUNC(efl_text_horizontal_align_auto_type_set, _efl_canvas_textblock_efl_text_format_text_horizontal_align_auto_type_set),
      EFL_OBJECT_OP_FUNC(efl_text_horizontal_align_auto_type_get, _efl_canvas_textblock_efl_text_format_text_horizontal_align_auto_type_get),
      EFL_OBJECT_OP_FUNC(efl_text_vertical_align_set, _efl_canvas_textblock_efl_text_format_text_vertical_align_set),
      EFL_OBJECT_OP_FUNC(efl_text_vertical_align_get, _efl_canvas_textblock_efl_text_format_text_vertical_align_get),
      EFL_OBJECT_OP_FUNC(efl_text_line_gap_set, _efl_canvas_textblock_efl_text_format_line_gap_set),
      EFL_OBJECT_OP_FUNC(efl_text_line_gap_get, _efl_canvas_textblock_efl_text_format_line_gap_get),
      EFL_OBJECT_OP_FUNC(efl_text_line_rel_gap_set, _efl_canvas_textblock_efl_text_format_line_rel_gap_set),
      EFL_OBJECT_OP_FUNC(efl_text_line_rel_gap_get, _efl_canvas_textblock_efl_text_format_line_rel_gap_get),
      EFL_OBJECT_OP_FUNC(efl_text_tab_stops_set, _efl_canvas_textblock_efl_text_format_tab_stops_set),
      EFL_OBJECT_OP_FUNC(efl_text_tab_stops_get, _efl_canvas_textblock_efl_text_format_tab_stops_get),
      EFL_OBJECT_OP_FUNC(efl_text_password_set, _efl_canvas_textblock_efl_text_format_password_set),
      EFL_OBJECT_OP_FUNC(efl_text_password_get, _efl_canvas_textblock_efl_text_format_password_get),
      EFL_OBJECT_OP_FUNC(efl_text_replacement_char_set, _efl_canvas_textblock_efl_text_format_replacement_char_set),
      EFL_OBJECT_OP_FUNC(efl_text_replacement_char_get, _efl_canvas_textblock_efl_text_format_replacement_char_get),
      EFL_OBJECT_OP_FUNC(efl_text_markup_set, _efl_canvas_textblock_efl_text_markup_markup_set),
      EFL_OBJECT_OP_FUNC(efl_text_markup_get, _efl_canvas_textblock_efl_text_markup_markup_get),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_scale_set, _efl_canvas_textblock_efl_gfx_entity_scale_set),
      EFL_CANVAS_TEXTBLOCK_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"is_empty", NULL, __eolian_efl_canvas_textblock_is_empty_get_reflect},
      {"bidi_delimiters", __eolian_efl_canvas_textblock_bidi_delimiters_set_reflect, __eolian_efl_canvas_textblock_bidi_delimiters_get_reflect},
      {"newline_as_paragraph_separator", __eolian_efl_canvas_textblock_newline_as_paragraph_separator_set_reflect, __eolian_efl_canvas_textblock_newline_as_paragraph_separator_get_reflect},
      {"all_styles", NULL, __eolian_efl_canvas_textblock_all_styles_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_textblock_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Textblock",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Canvas_Textblock_Data),
   _efl_canvas_textblock_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_textblock_class_get, &_efl_canvas_textblock_class_desc, EFL_CANVAS_OBJECT_CLASS, EFL_TEXT_INTERFACE, EFL_CANVAS_FILTER_INTERNAL_MIXIN, EFL_TEXT_FONT_PROPERTIES_INTERFACE, EFL_TEXT_STYLE_INTERFACE, EFL_TEXT_FORMAT_INTERFACE, EFL_TEXT_MARKUP_INTERFACE, EFL_UI_I18N_INTERFACE, NULL);
